package visualDB;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

public class InsertData_OracleToMysql {

	DBConnectionKisun pool=null;
	DBKisunOracle ora_pool=null;
	Connection conn=null, ora_conn=null;
	Statement stmt=null, ora_stmt=null;
	ResultSet rs = null;
	ResultSetMetaData rsmd=null;
	PreparedStatement pstmt = null;
	String query;
	
	
	public InsertData_OracleToMysql(OracleLoginData ora_log, MysqlLoginData m_log, String oraTable, String mTable) throws Exception{
		// db, ip, portȣ, db, user,  
		pool = DBConnectionKisun.getInstance("mysql", m_log.getM_ip(), m_log.getM_port(), m_log.getM_dbName(), m_log.getM_id(), m_log.getM_pw());
		conn = pool.getConnection();
		stmt = conn.createStatement();
		
		ora_pool = DBKisunOracle.getInstance(ora_log.getOracle_ip(),ora_log.getOracle_port(), ora_log.getOracle_dbname(), ora_log.getOracle_id(), ora_log.getOracle_pw());
		ora_conn = ora_pool.getConnection();
		ora_stmt = ora_conn.createStatement();
			
		System.out.println("̼ ø!\n======================");
		insertData(oraTable, mTable);
		System.out.println("Ÿ ԿϷ");
		
		if(stmt!=null)
			stmt.close();
		if(ora_stmt!=null)
			ora_stmt.close();
		if(conn!=null)
			conn.close();
		if(ora_conn!=null)
			ora_conn.close();
		
		
	}
	
	public InsertData_OracleToMysql() throws Exception{
	}
		
	public void insertData(String table, String newtable)
	{
		//********************************************************** newtable ؾ ******************** newtable ******
		String insertStr = "insert into "+newtable+"("+getColumnName(newtable)+") values("+getColumnQuestion(newtable)+")";
		System.out.println(insertStr);
		int rowCount=getRowCount(table);
		System.out.println(" (row):"+rowCount);		
		int colCount = getColumnCount(newtable);
		System.out.println(" (column):"+colCount);	
		
		int datatype[] = getColumnType(table, colCount);
		for(int i=0;i<colCount;i++)
			System.out.print("\t"+datatype[i]);
		System.out.println("");
		
		
		
		query="select * from "+table;	
		try {
			rs = ora_stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			int columnCount = rsmd.getColumnCount();
			while(rs.next())
			{
				System.out.println("----------------- ");
				
				
				pstmt = conn.prepareStatement(insertStr);				
				
				for(int i=1;i<=columnCount;i++)
				{
					switch(rsmd.getColumnType(i))
					{
						case 1: System.out.print(rsmd.getColumnName(i)+":"+rs.getString(i)+"\t");
							pstmt.setString(i, rs.getString(i));
							break;
						case 2: System.out.print(rsmd.getColumnName(i)+":"+rs.getString(i)+"\t");
						pstmt.setString(i, rs.getString(i));
							break;
						case 12: System.out.print(rsmd.getColumnName(i)+":"+rs.getString(i)+"\t");
							pstmt.setString(i, rs.getString(i));
							break;
						case 4: System.out.print(rsmd.getColumnName(i)+":"+rs.getInt(i)+"\t");
							pstmt.setInt(i, rs.getInt(i));
							break;
						case -1: System.out.print(rsmd.getColumnName(i)+":"+rs.getString(i)+"\t");
							pstmt.setString(i, rs.getString(i));
							break;
						case 91: System.out.print(rsmd.getColumnName(i)+":"+rs.getDate(i)+"\t");
							pstmt.setDate(i, rs.getDate(i));
							break;
						default : System.out.print(rsmd.getColumnName(i)+":"+rs.getString(i)+"\t");
							pstmt.setString(i, rs.getString(i));
						break;						
					}					
				}
				pstmt.executeUpdate();
				
				System.out.println();
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}
		
	}

	public int[] getColumnType(String table, int size)	//newTable ;(date), 
	{
		query="select * from "+table;	
		int columnType[]=new int[size];
		
		try {
			rs = ora_stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			int a=1, arr=0;;
			while(a<=size)
			{
				columnType[arr]=rsmd.getColumnType(a);				
				arr++;
				a++;
			}

		} catch (SQLException e) {
			e.printStackTrace();
		}
		return columnType;
	}
	public int getColumnCount(String table)	//newTable ;(date)
	{
		query="select * from "+table;	
		int columnCount=0;
		try {
			rs = stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			columnCount = rsmd.getColumnCount();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return columnCount;
	}

	public String getColumnQuestion(String table)	//newTable ;(date)
	{
		query="select * from "+table;	
		String _str="";
		try {
			rs = stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			int columnCount = rsmd.getColumnCount();
			int a=1;
			while(a<=columnCount)
			{
				if(a!=columnCount)
				_str =_str+ "?, ";	
				else
					_str =_str+ "?";	
				
				a++;
			}


		} catch (SQLException e) {
			e.printStackTrace();
		}
		return _str;
	}

	public String getColumnName(String table)	//newTable ;(date)
	{
		query="select * from "+table;	
		String _str="";
		try {
			rs = stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			int columnCount = rsmd.getColumnCount();
			int a=1;
			while(a<=columnCount)
			{
				if(a!=columnCount)
				_str =_str+ rsmd.getColumnName(a)+", ";	
				else
					_str =_str+ rsmd.getColumnName(a);	
				
				a++;
			}


		} catch (SQLException e) {
			e.printStackTrace();
		}
		return _str;
	}

	public int getRowCount(String table)
	{
		int row=0;
		String _str="";
		query="select count(*) from "+table;
		try {
			rs = ora_stmt.executeQuery(query);
			rs.next();
			_str = rs.getString(1);
			row = Integer.parseInt(_str);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return row;
	}
	
	public static void main(String[] args) throws Exception {
		new InsertData_OracleToMysql();
	}


}
