package visualDB;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;

public class OracleDataDao {

	DBKisunOracle pool=null;
	Connection conn=null;
	String table = null;
	
	public OracleDataDao(){	}
	
	public OracleDataDao(OracleLoginData ora_login, String tble)
	{
		pool = DBKisunOracle.getInstance(ora_login.getOracle_ip(), ora_login.getOracle_port(), ora_login.getOracle_dbname(), ora_login.getOracle_id(),ora_login.getOracle_pw());
	
		try {
			conn = pool.getConnection();			
		} catch (Exception e) {
			e.printStackTrace();
		}
			table = tble;		
	}

	public void conClose() {
		try {
			conn.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	public Vector getOracleData()
	{
		Vector result = new Vector(10,10);
		PreparedStatement pstmt=null; 
		try{
			String sql = "select * from "+table;
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();
			
			result = ResultSetToVector(rs);
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}finally{
		
			try{
				pstmt.close();
			}catch(Exception ee){}
		}
		return result;
	}

	public Vector getOracleTitleData()
	{
		Vector result = new Vector(10,10);
		PreparedStatement pstmt=null; 
		try{
			String sql = "select * from "+table;
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();
			
			result = ResultSetTitleVector(rs);
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}finally{
		
			try{
				pstmt.close();
			}catch(Exception ee){}
		}
		return result;
		
	}
	
	private Vector ResultSetTitleVector(ResultSet rs) throws Exception {
		Vector result = new Vector(10,10);
		ResultSetMetaData rsmtdt = rs.getMetaData();
		int totalColumnCount = rsmtdt.getColumnCount();
		if(rs.next())
		{
			for(int i = 1;i<=totalColumnCount;i++)
			{
				result.add(rsmtdt.getColumnName(i));
			}
			
		}		
		
		return result;
	}

	private Vector ResultSetToVector(ResultSet rs) throws Exception{
		Vector result = new Vector(10,10);
		ResultSetMetaData rsmtdt = rs.getMetaData();
		int totalColumnCount = rsmtdt.getColumnCount();
		while(rs.next())
		{
			Vector v = new Vector();
			for(int i = 1;i<=totalColumnCount;i++)
			{
				String columnName = rsmtdt.getColumnName(i);
				v.add(NullToBlank(rs.getString(columnName)));
			}
			result.add(v);
		}		
		
		return result;
	}

	private String NullToBlank(String string) {
		// TODO ڵ  ޼ҵ 
		return ( string==null )? "" : string ;
	}
	
	
}
